#property indicator_chart_window //   
#property indicator_buffers 7
#property indicator_color1 Magenta // 
#property indicator_color3 Green // . . 
#property indicator_color4 Red // . . 
#property indicator_color6 Green //  
#property indicator_color7 Red //  
//  
extern double OverSold=9; //    %% ( =100- )
extern int K=4; // %K
 bool applied_price=0; //   : 0-High&Low, 1-Close&Close
extern int Slow=2; //  ("-" HLorClose=1   Close&Close)
extern bool countMode=0; // 0 -   , 1 -     
extern bool HLorClose=1; //    : 0-High&Low, 1-Close&Close
extern int Border=2; //     
extern bool Trail=1; // 1 -       
extern int WideMin=8; //   
 bool WideMode=0; //    : 0 -  High/Low; 1 -   
extern int ShowChannel=2; //  1 -   , 2 -   
extern int ShowZigZag=0; //  1 -   , 2 -   
 bool count=1; //    ; 1 -     

// .
double   ZZpeak[], // 
         ZZtrough[], // 
         ChTop[], // . . 
         ChBot[], // . . 
         BaseInd[]; //   - 
double   Support[]; //  
double   Resist[]; //  
//  
double OverBought; //  
bool dir; // 0- , 1 - 
double top,bot; // , 
int jDn,jUp; //    
double brd; //    
bool trend,trendPrev;
double wide; // .    
bool vlt=1; //   
double topPrev,botPrev,topW,botW,topWprev,botWprev;
string ShortName="Trend@Stoch";
bool first;
int NameCount;
string _ID,NAME[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   _ID=GetID(ShortName); //     ( )

   if(K<0) {K=-K; applied_price=1;} //    
   if(Slow<0) {Slow=-Slow; HLorClose=1;} //    
   if(Border<0) {Border=-Border; Trail=0;} //   
   if(WideMin<0) {WideMin=-WideMin; WideMode=1;} //    
   if(ShowZigZag<0 || ShowChannel<0) count=0;
   ShowZigZag=MathAbs(ShowZigZag); ShowChannel=MathAbs(ShowChannel);

   OverBought=100.0-OverSold; //  
   brd=Border*Point; //    
   wide=WideMin*Point; // .    
//---- indicators
   SetIndexBuffer(0,ZZpeak);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Peak");
   
   SetIndexBuffer(1,ZZtrough);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Trough");
   
   if(ShowZigZag>0) {
      SetIndexStyle(0,DRAW_ZIGZAG);
      SetIndexStyle(1,DRAW_ZIGZAG);
     }
   else {      
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
     }

   SetIndexBuffer(2,ChTop);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"ChTop");

   SetIndexBuffer(3,ChBot);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexLabel(3,"ChBot");

   if(ShowChannel>0) {
      SetIndexStyle(2,DRAW_LINE,2);
      SetIndexStyle(3,DRAW_LINE,2);
     }
   else {      
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
     }

   SetIndexBuffer(4,BaseInd);
   SetIndexStyle(4,DRAW_NONE);
   string _st="St("+K+","+Slow+")";
   SetIndexLabel(4,_st);

   SetIndexBuffer(5,Support);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(5,DRAW_LINE,0,2);
   SetIndexLabel(5,"Support");


   SetIndexBuffer(6,Resist);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(6,DRAW_LINE,0,2);
   SetIndexLabel(6,"Resist");
//----
//   IndicatorShortName(ShortName); 

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit();
   int limit=Bars-ic-1; // - 
   int i,iter=0;

   for(i=limit; i>=0; i--)
     {
      BaseInd[i]=iStochastic(NULL,0,K,1,Slow,0,applied_price, 0,i); 

      iter++; if(iter>1) {
         i++;
         double st=BaseInd[i]; 
         jDn++; jUp++; //    

         bool up=st>=OverBought; // 1 -   
         bool dn=st<=OverSold; // 1 -   
      
         static double topPrev,botPrev,topW,botW,topWprev,botWprev;
      
         if(dir) { //    
            if(up) { //    
               double l=High[i]*100;
               if(count) {for(int k=jUp; k>=0; k--) if(Low[i+k]<l) {int sh=i+k;l=Low[i+k];}}
               else {for(k=0; k<=jUp; k++) if(Low[i+k]<l) {sh=i+k;l=Low[i+k];}}
               bot=Low[sh]; //  = 
            
               if(WideMode) {if(top-bot<wide && botPrev<bot) botW=botPrev; else botW=bot;}
               else {if(High[i]-bot<wide && botPrev<bot) botW=botPrev; else botW=bot;}
               if(trend && Trail && botWprev>botW) botW=botWprev;
               if(ShowZigZag==1) ZZtrough[sh]=bot; else ZZtrough[i]=bot;
               if(ShowChannel==1) for(k=sh; k>i; k--) ChBot[k]=botW;
               dir=0; botPrev=bot; botWprev=botW;
              }
           }
         else {
            if(dn) {
               double h=0;
               if(count) {for(k=jDn; k>=0; k--) if(High[i+k]>h) {sh=i+k; h=High[i+k];}}
               else {for(k=0; k<=jDn; k++) if(High[i+k]>h) {sh=i+k; h=High[i+k];}}
               top=High[sh];

               if(WideMode) {if(top-bot<wide && topPrev>top) topW=topPrev; else topW=top;}
               else {if(top-Low[i]<wide && topPrev>top) topW=topPrev; else topW=top;}
               if(!trend && Trail && topWprev<topW) topW=topWprev;
               if(ShowZigZag==1) ZZpeak[sh]=top; else ZZpeak[i]=top;
               if(ShowChannel==1) for(k=sh; k>i; k--) ChTop[k]=topW;
               dir=1; topPrev=top; topWprev=topW;
              }
           }

      //  
      static bool upDisable,dnDisable;
      if(up && (!upDisable||countMode)) {
         jUp=-2; 
         upDisable=1; dnDisable=0;
        }
      if(dn && (!dnDisable||countMode)) {
         jDn=-2;
         dnDisable=1; upDisable=0;
        }

         for(k=0; k<2; k++) {ChTop[i-k]=topW; ChBot[i-k]=botW;}
         
         i--;
        }

//=============
      double TopBrd=topW+brd; // ..  
      double BotBrd=botW-brd; // ..  

      if(HLorClose) { //   Close   
         if(Close[i+1]>TopBrd) trend=1;
         if(Close[i+1]<BotBrd) trend=0;
        }
      else { //   High/Low
         if(High[i]>TopBrd) trend=1;
         if(Low[i]<BotBrd) trend=0;
        }
      
      if(trend) Support[i]=BotBrd; //   ,   
      else Resist[i]=TopBrd; //   ,   
      
      if(trendPrev!=trend) //   ,     Support-Resist
         if(trend) {Support[i+1]=Resist[i+1]; Resist[i]=0.0;}
         else {Resist[i+1]=Support[i+1]; Support[i]=0.0;}

      trendPrev=trend;
     }
        
   SN(); //       

   return(0);
  }


int reinit() // -  
  {
   ArrayInitialize(ZZpeak,0.0);
   ArrayInitialize(ZZtrough,0.0);
   ArrayInitialize(ChTop,0.0);
   ArrayInitialize(ChBot,0.0);
   ArrayInitialize(BaseInd,0.0);
   ArrayInitialize(Support,0.0);
   ArrayInitialize(Resist,0.0);
   dir=0;top=0;bot=0;jDn=0;jUp=0;trend=0;first=0;
   topPrev=0;botPrev=0;topW=0;botW=0;topWprev=0;botWprev=0;
   deinit();
   return(0);
  }
  

void SN() { //    0- 
   if(first) return;
   first=1;

   if(applied_price) string _name="Stoch-C/C";
   else _name="Stoch-H/L";
   _name=_name+"("+K+","+Slow+") "+DoubleToStr(OverSold,0)+"/"+DoubleToStr(OverBought,0)+" W:"+WideMin+
   " B:"+Border;
   if(HLorClose) _name=_name+" C-C";
   else _name=_name+" H-L";
   if(Trail) _name=_name+" Trail";
   string _label; _label=Name("Label:"); 
   ObjectCreate(_label,OBJ_LABEL,0,0,0);
   ObjectSet(_label,OBJPROP_CORNER,0);
   ObjectSet(_label,OBJPROP_XDISTANCE,3);
   ObjectSet(_label,OBJPROP_YDISTANCE,15);
   ObjectSetText(_label,_name,8,"Arial",Green);
   
   WindowRedraw();
  }

string Name(string obj) {
   NameCount++; //  . 
   string _Name=ShortName+"|"+_ID+"|"+obj+NameCount; //   = . +    +  .
   ArrayResize(NAME,NameCount); //   .   1
   NAME[NameCount-1]=_Name; //     

   return(_Name); //    
  }

int deinit() {
   for(int i=0; i<NameCount; i++) ObjectDelete(NAME[i]); //    
   ArrayResize(NAME,1); NameCount=0; //    
   return(0);
  }

//   ()  
string GetID(string ShortName) {
   string _GV=ShortName; //     
   int ID=GlobalVariableGet(_GV); //    ()  
   ID++; //  
   GlobalVariableSet(_GV,ID); //    .; ( .. ,  ) 
   
   return(DoubleToStr(ID,0)); //   ()  
  }

